var Immutable = require('immutable');

// Everything in the lists should be lowercase. Potential matches will also 
// be converted to lowercase.

var lists = {
  // falsePositivesList should contain only the singular forms of the words, 
  // words will be singularized before being checked against this list.
  falsePositives: [
    'rt',
    'http',
    'https',
    'haha',
    'adv',
    'san',
    'tri',
    'asa',
    'att',
    'io',
    'imo',
    'pl',
    'dr',
    'ala',
    'ama',
    'ive'
  ],
  extendedBlacklist: [
    'negro',
    'negroes',
    'chink',
    'chinks',
    'gook',
    'gooks',
    'slant-eye',
    'slant-eyes',
    'slanty-eye',
    'slanty-eyes',
    'nigger',
    'niggers',
    'nigga',
    'niggas',
    'spic',
    'spics',
    'rape',
    'rapes',
    'rapist',
    'rapists',
    'raping',
    'bombing',
    'bombings',
    'shootings',
    'shooting',
    'shooter',
    'miscarriage',
    'miscarriages',
    'coon',
    'coons',
    'transgender', // OK normally, not OK as a noun.
    'transgenders', // OK normally, not OK as a noun.
    'swastika',
    'swastikas',
    'nazi',
    'nazis',
    'supremacy',
    'supremacist',
    'supremacists',
    'white-supremacist',
    'white-supremacists',
    'nazidom',
    'nazism',
    'naziism',
    'nazisms',
    'naziisms',
    'stormer',
    'stormers',
    'terrorist',
    'terrorists',
    'holocaust',
    'islamist',
    'islamists',
    'jihadist',
    'jihadists',
    'klan',
    'klans',
    'blackface',
    'blackfaces',
    'abuser',
    'abusers',
    'n-word',
    'n-words',
    'darky',
    'darkies',
    'wigger',
    'wiggers',
    'crip',
    'crips',
    'cripple',
    'cripples',
    'pedophile',
    'pedophiles',
    'pedophilia',
    'cancer',
    'cancers',
    'seizure',
    'seizures',
    'eulogy',
    'eulogies',
    'lynching',
    'lynchings',
    'slaveowner',
    'slaveowners',
    'condolence',
    'condolences',
    'RIP',
    'molestation',
    'molestations',
    'molester',
    'molesters',
    'triggering',
    'trigger',
    'brownface',
    'niggaz',
    'harelip',
    'harelips',
    'invalid',
    'invalids',
    'moron',
    'morons',
    'spaz',
    'spazzes',
    'pedo',
    'pedos',
    'negress',
    'blackamoor',
    'towelhead',
    'towelheads',
    'muzzy',
    'muzzie',
    'muzzies',
    'boylove',
    'childlove',
    'boylovers',
    'childlovers'
  ],
  tragedyModeBlacklist: [
    'gaza',
    'israel',
    'palestine',
    'invasion',
    'horror',
    'genocide',
    'explosion',
    'assault',
    'hamas',
    'bomb',
    'plane',
    'death',
    'missile',
    'crash',
    'suicide',
    'airstrike',
    'brigadier',
    'idf',
    'isis',
    'mourner',
    'mourners',
    'iraq',
    'accident',
    'ebola',
    'depression',
    'asphyxiation',
    'ferguson',
    'beheading',
    'foley',
    'gun',
    'guns',
    'rifle',
    'rifles',
    'gunshot',
    'gunshots',
    'gunfire',
    'semiautomatic',
    'semiautomatics',
    'automatic',
    'automatics',
    'silencer',
    'silencers',
    'firearm',
    'firearms',
    'bloodshed',
    'rip',
    'chokehold',
    'coroner',
    'eric',
    'garner',
    'torture',
    'torturer',
    'torturing',
    'ukraine',
    'donetsk',
    'jihad',
    'grieving',
    'walter',
    'scott',
    'cop',
    'police',
    'officer',
    'nepal',
    'earthquake',
    'katmandu',
    'Durbar',
    'wreckage',
    'carnage',
    'riot',
    'rioting',
    'baltimore',
    'freddie',
    'gray',
    'derailment',
    'amtrak',
    'train',
    'philadelphia',

    'rev',
    // 'sharonda',
    // 'coleman',
    'singleton',

    // 'cynthia',
    'hurd',

    // 'susie',
    // 'jackson',

    'ethel',
    'lance',

    // 'depayne',
    // 'middleton',
    // 'doctor',

    // 'clementa',
    // 'pinckney',

    // 'tywanza',
    // 'sanders',
    'sander',

    'daniel',
    // 'simmons',
    'simmon',

    // 'myra',
    // 'thompson',

    'ame',
    'emanuel',
    'victim',
    'charleston',
    'columbia',
    'racist',
    'supremacist',
    'racism',
    'supremacy',
    'dylann',
    'roof',
    'murder',
    'murderer',
    'whiteness',
    'rhodesian',
    'rhodesia',
    'funeral',
    'arson',
    'firebombing',
    'killed',

    // 'cameraman',
    // 'virginia',
    'gunmen',
    'gunman',
    // 'inland',

    // 'brussel',
    // 'brussels',

    'casualties',
    'casualty',

    // 'orlando',
    // 'pulse',
    // 'nightclub',
    // 'mateen',
    // 'omar',

    'sniper',
    // 'dallas',

    // 'baton',
    // 'rouge'
    // 'chelsea',
    // 'manhattan',
    'blast',

    'antisemitism',
    'anti-semitism',
    'antisemite',
    'antisemites',
    'anti-semite',
    'anti-semites',

    'tomahawk',
    'tomahawks',
    'missile',
    'missiles',
    'syria',
    'syrian',
    'syrians',

    // 'manchester',
    // 'ariana',
    // 'grande',

    // 'borough',
    // 'vauxhall',

    // 'acid',
    // 'khan'
    'uva',
    'virginia',
    'cville',
    'charlottesville',
    'torch',
    'torches',
    'percenter',
    'tiki',
    'driver',
    'heyer',
    'heather',
    // 'field',
    // 'barcelona',
    // 'spain',
    // 'ramblas',
    // 'van',
    // 'catalonia',
    // 'catalonian',
    // 'catalonians',
    // 'houston',
    'flood',
    'floods',
    'storm',
    'storms',
    'hurricane',
    'hurricanes',
    'tornado',
    'tornadoes',
    'tornados',

    // 'vegas',
    // 'country',
    // 'stampede',
    // 'stampedes',
    // 'hospital',
    // 'hospitals',
    // 'aldean',
    // 'paddock',
    // 'paddocks',
    // 'mandalay',

    // 'manhattan',
    // 'depot',
    // 'cyclist',
    // 'cyclists',
    // 'bicyclist',
    // 'bicyclists',

    'sutherland',
    'springs',
    'spring',
    'church',
    'churches',
    'texas',

    'florida',
    'parkland',
    'cruz',
    'stoneman',
    'broward',
    'lockdown',
    'classmate',
    'classmates',
    'school',
    'schools',

    'toronto'
  ],
  whitelist: [
  ]
};

// TODO: Differentiate between words not cool to say vs. words not cool to
// respond to.

module.exports = Immutable.Map(lists);
